; 
    include \masm32\include\masm32rt.inc
    .686
    include counter2.asm
; 
    .data
      recip100 dd 0
    .code
; 
start:
; 

    xor eax, eax
    mov edx, 1
    mov ecx, 100
    div ecx
    inc eax
    mov recip100, eax

    print "Reciprocal Divisor "
    print ustr$(recip100),13,10

    invoke Sleep, 3000

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      xor edx, edx
      mov eax, 123
      mov ecx, 100
      div ecx
    ctr_end
    print ustr$(eax)
    print chr$(" cycles, div",13,10)

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      mov eax, 123
      mul recip100
    ctr_end
    print ustr$(eax)
    print chr$(" cycles, reciprocal divisor (mul mem)",13,10)

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      mov eax, 123
      mov edx, recip100
      mul edx
    ctr_end
    print ustr$(eax)
    print chr$(" cycles, reciprocal divisor (mul reg)",13,10)

    inkey "Press any key to test range..."

    ;xor esi, esi
    mov esi, 1073000000
    .while esi <= 0ffffffffh

      repeat 1000

        mov eax, esi
        mul recip100
        mov edi, edx

        xor edx, edx
        mov eax, esi
        mov ecx, 100
        div ecx

        .if eax != edi
          print "Mismatch at "
          print ustr$(esi),13,10
          .break
        .endif

        inc esi

      endm

      print ustr$(esi),13,10

      invoke Sleep, 1

    .endw
    
    inkey "Press any key to exit..."
    exit
; 
end start
 